VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "QR Code Decode Library Sample"
   ClientHeight    =   2685
   ClientLeft      =   6975
   ClientTop       =   6240
   ClientWidth     =   5235
   LinkTopic       =   "Form1"
   ScaleHeight     =   2685
   ScaleWidth      =   5235
   Begin VB.PictureBox CommonDialog1 
      Height          =   480
      Left            =   4320
      ScaleHeight     =   420
      ScaleWidth      =   1140
      TabIndex        =   1
      Top             =   0
      Width           =   1200
   End
   Begin VB.TextBox txtDecodeResult 
      Height          =   2655
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      OLEDropMode     =   1  '蓮
      ScrollBars      =   2  '
      TabIndex        =   0
      Top             =   0
      Width           =   5175
   End
   Begin VB.Menu menuFile 
      Caption         =   "t@C(&F)"
      Begin VB.Menu menuFileOpen 
         Caption         =   "J(&O)..."
         Shortcut        =   ^O
      End
      Begin VB.Menu SEPARETOR 
         Caption         =   "-"
      End
      Begin VB.Menu menuAppExit 
         Caption         =   "I(&X)"
      End
   End
   Begin VB.Menu menuSetting 
      Caption         =   "ݒ(&S)"
      Begin VB.Menu menuSetDecodeRect 
         Caption         =   "fR[h͈͎w(&R)..."
      End
      Begin VB.Menu menuSetDecodeProperty 
         Caption         =   "fR[hݒ(&P)..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'fR[h͈͎wifrmSetRectŐݒj
Public blnEnableSetRect As Boolean
Public lngRectLeft As Long
Public lngRectTop As Long
Public lngRectRight As Long
Public lngRectBottom As Long

'fR[hݒifrmSetPropertyŐݒj
Public lngSymbolCount As Long
Public lngEffectLevel As Long
Public byBorder As Byte
Public byModuleSize As Byte

Dim intFilterIndex As Integer

Private Sub Form_Load()

    blnEnableSetRect = False
    lngRectLeft = 0
    lngRectTop = 0
    lngRectRight = 0
    lngRectBottom = 0

    lngSymbolCount = 0
    lngEffectLevel = 3
    byBorder = 0
    byModuleSize = 1

    intFilterIndex = 1 'sN`t@C

End Sub

Private Sub Form_Resize()

    'eLXg{bNXNCAg̈ɍ킹ĕ\
    txtDecodeResult.Width = Me.ScaleWidth
    txtDecodeResult.Height = Me.ScaleHeight

End Sub

Private Sub txtDecodeResult_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)

    't@Ĉ݃hbOhbv󂯕t
    Effect = IIf(Data.GetFormat(vbCFFiles), vbDropEffectCopy, vbDropEffectNone)

End Sub

Private Sub txtDecodeResult_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
't@Chbv

    DecodeFile Data.Files(1)

End Sub

Private Sub menuFileOpen_Click()
'[t@C]-[J]

    Me![CommonDialog1].FilterIndex = intFilterIndex

    'R_CAOɂt@CI
    On Error GoTo OpenCancel
    Me![CommonDialog1].ShowOpen
    On Error GoTo 0

    intFilterIndex = Me![CommonDialog1].FilterIndex

    DecodeFile Me![CommonDialog1].FileName

OpenCancel:

End Sub

Private Sub menuAppExit_Click()
'vOI

    Unload Me

End Sub

Private Sub menuSetDecodeRect_Click()
'fR[h͈͎w_CAO\

    frmSetRect.Show 1 '[_\

End Sub

Private Sub menuSetDecodeProperty_Click()
'fR[hݒ_CAO\

    frmSetProperty.Show 1 '[_\

End Sub

Private Sub DecodeFile(ByVal strFilePath As String)
'摜t@CΏۂƂfR[h

    Dim intOldPointer As Integer

    'fR[h͍vJ[\\
    Me.MousePointer = vbHourglass

    'DLLt@NVɂfR[h
    Dim lngResult As Long

    If blnEnableSetRect Then
        '͈͎w肠
        lngResult = DecodePictureFileRect(strFilePath, lngRectLeft, lngRectTop, lngRectRight, lngRectBottom)
    Else
        '͈͎wȂ
        lngResult = DecodePictureFile(strFilePath)
    End If

    'J[\
    Me.MousePointer = vbDefault

    Dim strResult As String

    If lngResult >= 1 Then
        'fR[hI
        Dim i As Long

        For i = 0 To lngResult - 1
            strResult = strResult + "" + vbCrLf

            'tH[}bg
            strResult = strResult + "fR[h f[^ " + Format(i + 1)
            strResult = strResult + " [^:" + Format(GetDecodeVersion(i))
            strResult = strResult + ", x:"

            Select Case GetDecodeLevel(i)
                Case 0
                    strResult = strResult + "L(7%)"
                Case 1
                    strResult = strResult + "M(15%)"
                Case 2
                    strResult = strResult + "Q(25%)"
                Case 3
                    strResult = strResult + "H(30%)"
            End Select

            'A
            Dim lngCount As Long
            Dim lngSeqNo As Long
            Dim byCheckDigit As Byte

            lngCount = GetConcatenationInfo(i, lngSeqNo, byCheckDigit)

            If lngCount > 0 Then
                strResult = strResult + ", A:" + Format(lngSeqNo + 1) + "/" + Format(lngCount)
                strResult = strResult + "(CD:" + Hex(byCheckDigit \ &H10) + Hex(byCheckDigit Mod &H10) + "H)"
            End If


            strResult = strResult + "]" + vbCrLf
            strResult = strResult + "" + vbCrLf

            'V{f[^
            strResult = strResult + GetDecodeDataString(i) + vbCrLf + vbCrLf

            'ʒu
            Dim lngPosition(7) As Long

            lngResult = GetSymbolePosition(i, lngPosition(0))

            strResult = strResult + "V{ʒuF" + _
                                    "(" + Format(lngPosition(0)) + ", " + Format(lngPosition(1)) + ")-" + _
                                    "(" + Format(lngPosition(2)) + ", " + Format(lngPosition(3)) + ")-" + _
                                    "(" + Format(lngPosition(4)) + ", " + Format(lngPosition(5)) + ")-" + _
                                    "(" + Format(lngPosition(6)) + ", " + Format(lngPosition(7)) + ")"

            strResult = strResult + vbCrLf + vbCrLf
        Next i

        'fR[hʕۑJ
        FreeAllocateMemory

    Else
        'fR[hG[
        Select Case lngResult

            Case QRD_ERROR_SYMBLE_NOT_FOUND
                strResult = "QRR[h V{ǂݎ܂łB"

                Select Case GetErrorLevel
                    Case 1
                        strResult = strResult + vbCrLf + "(ʒuop^[܂łB)"
                    
                    Case 2
                        strResult = strResult + vbCrLf + "(ʒuop^[V{Fł܂łB)"
                    
                    Case 3
                        strResult = strResult + vbCrLf + "(f[^̓ǂݎɎs܂B)"
                
                End Select

            Case QRD_ERROR_FILE_NOT_FOUND
                strResult = "t@C܂łB"

            Case QRD_ERROR_READ_FAULT
                strResult = "t@CǂݍݒɃG[܂B"

            Case QRD_ERROR_BAD_FORMAT
                strResult = "ǂݎłȂt@CʂłB"

            Case QRD_ERROR_SHARING_VIOLATION
                strResult = "Lᔽɂt@Cǂݎ邱Ƃł܂łB"

            Case QRD_ERROR_NOT_ENOUGH_MEMORY
                strResult = "słB"

        End Select
    End If

    Me![txtDecodeResult].Text = strResult

End Sub
